


#ifndef WORLD_H
#define WORLD_H

#include <stdlib.h>

#include "npc.h"
#include "player.h"
#include "environment.h"
#include "shoot_laser.h"
#include "stdincl.h"

class World {

 public:
  World ();
  ~World ();

  /* for easier use: map the first two player here */
  Player *localPlayer;
  Player *player1;
  Player *player2;

  /* a list of all players */
  struct playerList {
    playerList* next;
    Player* player;
    int number;
  };
  playerList* lastPlayer;

  /* a list of all non-player-characters */
  struct npcList {
    npcList* next;
    NPC* npc;
    int number;
  };
  npcList* lastNPC;

  /* a list of all environmental objects */
  struct envList {
    envList* next;
    Environment* env;
    int number;
  };
  envList* lastEnv;

  /* a list of all shoot-amental objects */
  struct shootList {
    shootList* next;
    ShootLaser* shoot;
    int number;
  };
  shootList* lastShoot;


  bool addPlayer(Player* player);
  bool removePlayer(Player* player);
  Player* getLocalPlayer();
  bool addNPC(NPC* npc);
  bool removeNPC(NPC* npc);
  bool addEnv(Environment* env);
  bool addShoot(ShootLaser* shoot);

  void drawWorld(void);
  void initEnvironement(void);
  void updateWorld(void);
  void testThaTest(void);

 private:
  float surface[120][120];


};

#endif
